
x1 = 137;
x2 = 95;
wheel = 15;
y  = 170;
h  = 6;

module door(lx1, lx2) {
	linear_extrude(.01)
	minkowski() {
		polygon([
				[lx1/2,-y/2], [lx2/2,y/2],
				[-lx2/2,y/2], [-lx1/2,-y/2]
		]);
		circle(r=2,$fn=100);
	}
}


module doorcut(lx1, lx2) {
	linear_extrude(100)
		polygon([
				[-lx1/2+wheel,-y/2],[-lx1/2+wheel*2,-y/2+30],
				[lx1/2-wheel*2,-y/2+30],[lx1/2-wheel,-y/2]
		]);
}

module doorslot(lx1, lx2) {
	scale([0.95,0.95,1])
		difference() {
			scale([1,1,3000]) door(lx1, lx2);
			scale([100,1.01,1]) translate([0,-2,-.01]) doorcut(lx1, lx2);
		}
}
module doorslotall(lx1, lx2) {
	difference(){
		doorslot( lx1, lx2 );
		translate([0,0.4,0])
			scale([0.97,0.97,10])
			doorslot( lx1, lx2 );
		translate([0,0,500+9])
			cube([1000,1000,1000],center=true);
	}
}
module doorslotfill(lx1,lx2) {
	scale([0.97,0.97,10])
		doorslot( lx1, lx2 );
}

module doorslotmask(lx1, lx2) {
	difference() {
		union() {
			translate([0,-0.5,0])
				difference(){
					scale([1.021,1.021,10])
						doorslot( lx1, lx2 );
					translate([0,0.4,0])
						scale([1.005,1.005,10])
						doorslot( lx1, lx2 );
					translate([0,0,500+7])
						cube([1000,1000,1000],center=true);
				}
			translate([0,0.4,0])
				difference(){
					scale([0.965,0.965,10])
						doorslot( lx1, lx2 );
					translate([0,0.0,0])
						scale([0.95,0.95,10])
						doorslot( lx1, lx2 );
					translate([0,0,500+7])
						cube([1000,1000,1000],center=true);
				}
			translate([0,-0.5,0])
				difference(){
					scale([1.15,1.15,10])
						doorslot( lx1, lx2 );
					translate([0,0.4,0])
						scale([0.95,0.95,10])
						doorslot( lx1, lx2 );
					translate([0,0,500+1])
						cube([1000,1000,1000],center=true);
				}
		}
	}
}

module wheel(){
	movez=4;
	rotate([0,180,0])
	translate([0.8,0,movez-0.1])
		scale([1.15,1.15,1])
		rotate_extrude($fn=200)
		polygon( points=[[0,-movez],[7.5,-movez],[7.5,2.8],[8,3.5],[8.0,4],[7.5,4.5],[7.1,5],
				[6.8,6],
				[6.8,10],
				[7.1,11],
				[7.5,11.5],
				[8.0,12],
				[8.0,12.5],
				[4.5,13],
				[4.5,13.5],
				[0,13.5],
		] );
}

module wheelrightholes(lx1, lx2) {
	translate([lx1/2 - 5.8,-y/2,6]) {
		cylinder(r=1,h=100,$fn=50,center=true);
	}
	translate([lx1/2-wheel*2+wheel/2,-y/2+30,5]) {
		cylinder(r=1,h=100,$fn=50,center=true);
	}
}

module wheelright(lx1, lx2) {
	translate([lx1/2 - 5.8,-y/2,6]) {
		wheel();
	}
	translate([lx1/2-wheel*2+wheel/2,-y/2+30,6]) {
		wheel();
	}
}
module wheels(lx1,lx2){
	wheelright(lx1,lx2);
	mirror([1,0,0])
		wheelright(lx1,lx2);
}
module wheelholes(lx1,lx2){
	wheelrightholes(lx1,lx2);
	mirror([1,0,0])
		wheelrightholes(lx1,lx2);
}


$fn=200;
w1 = 200;       // width of rectangle
h1 = 20;       // height of rectangle
l1 = y/2+6;      // length of chord of the curve
dh1 = 1;           // delta height of the curve

module curve(width, height, length, dh) {
    r = (pow(length/2, 2) + pow(dh, 2))/(2*dh);
    a = 2*asin((length/2)/r);
    translate([-r, 0, 0])
	    rotate_extrude(angle = a)
	    translate([r, 0, 0]) square(size = [height, width], center = true);
}

module hatchcurve() {
	translate([0,-3,13.5])
	rotate([-4.3,0,0])
	rotate([0,90,0])
		union(){ 
			curve(w1, h1, l1, dh1);
			mirror([1,0,0])rotate([180,0,0])curve(w1, h1, l1, dh1);
		}
}
module hatch() {
	difference() {
		union() {
			difference() {
				union() {
					difference() {
						union(){
							difference() {
								hull()
								{
									door(x1-10,x2);
									translate([0,0,h])
										door(x1,x2);
								}
								translate([0,-2.1,-1])
									doorcut(x1,x2);
							}
							wheels(x1,x2);
						}
						hatchcurve();
					}
					doorslotfill( x1, x2 );
				}

				wheelholes(x1,x2);

				translate([0,0,1.5])
					scale([1.01,1.01,1])
					doorslotfill( x1, x2 );
			}

			translate([0,70,1]) rotate([90,90,90]) difference() {
				cylinder(r=7,h=3,center=true,$fn=50);
				cylinder(r=4,h=4,center=true,$fn=50);
			}

			translate([0,0,0.00]) {
				difference() {
					doorslotall(x1,x2);
					translate([0,0,-500])
						rotate([-2,0,0])
						cube([1000,1000,1000],center=true);
				}
			}
		}

		translate([0,0,-500])
			cube([1000,1000,1000],center=true);
	}
}

hatch();

translate([190,0,0])
difference(){doorslotmask(x1,x2);wheelholes(x1,x2);}

